#!/bin/bash

#Converts dated mono files generated by a Tascam DR-680 with a Coresound Tetramic ambisonic microphone to B-format 4-channel wav files. Run this script in directory containing the mono files. Change paths as necessary. Use the command line argument --elf to enable extended low frequency response in the b-format output (-3dB at 40Hz) or none to use the default roll-off at 80Hz.

if [ "$1" = "--elf" ]; then
    config="elf"
else
    config="def"
fi


[ -d aformat ] || mkdir aformat
[ -d bformat ] || mkdir bformat
#[ -d bformat/48k16bit ] || mkdir bformat/48k16bit
#[ -d bformat/48k24bit ] || mkdir bformat/48k24bit

for file in *.wav 
do 
base=${file:0:11}
channelnumber=${file:15:1}

if [ "$channelnumber" = "1" ]; then
	       command="/usr/local/bin/makemulti --wav --24bit $file"
            fi
if [ "$channelnumber" = "2" ]; then
	       command="$command $file"
           fi
if [ "$channelnumber" = "3" ]; then
	       command="$command $file"
            fi
if [ "$channelnumber" = "4" ]; then
    command="$command $file $base"
    suffix="a-format.wav"
    command=$command$suffix
    $command
    aformatfile=$base$suffix
    mv ./$aformatfile ./aformat
    

    if [ "$config" = "elf" ]; then
	suffix="b-format_elf.wav"
    else
	suffix="b-format.wav"
    fi
    bformatfile=$base$suffix
    if [ "$config" = "elf" ]; then
	/usr/local/bin/tetrafile --fuma --wav --hpf 20 /home/iain/.tetraproc/CS2293-elf.tetra aformat/$aformatfile bformat/$bformatfile
    else
	/usr/local/bin/tetrafile --fuma --wav --hpf 20 /home/iain/.tetraproc/CS2293-def.tetra aformat/$aformatfile bformat/$bformatfile
    fi
    

    
    
# for 16bit 48kHz - use gain reduction if necessary	       
	 #      /usr/bin/sox bformat/$bformatfile -b 16 bformat/48k16bit/$bformatfile gain -0.0 rate 48000 dither -s

# for 24bit 48kHz - use gain reduction if necessary	       
#    /usr/bin/sox bformat/$bformatfile bformat/48k24bit/$bformatfile gain -0.0 rate 48000 
    
fi


done



rm -r aformat

exit 0